
const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');



const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class Quiz_questionsDBApi {
    

    
    static async create(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const quiz_questions = await db.quiz_questions.create(
            {
                id: data.id || undefined,
        
        prompt: data.prompt
        ||
        null
            ,
            
        time_limit_seconds: data.time_limit_seconds
        ||
        null
            ,
            
        points: data.points
        ||
        null
            ,
            
        question_type: data.question_type
        ||
        null
            ,
            
        order_index: data.order_index
        ||
        null
            ,
            
            importHash: data.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
    },
        { transaction },
    );

        
        await quiz_questions.setQuiz( data.quiz || null, {
            transaction,
        });
        

        

        
        await FileDBApi.replaceRelationFiles(
            {
                belongsTo: db.quiz_questions.getTableName(),
                belongsToColumn: 'prompt_images',
                belongsToId: quiz_questions.id,
            },
            data.prompt_images,
            options,
        );
        

        return quiz_questions;
    }
    

    static async bulkImport(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        // Prepare data - wrapping individual data transformations in a map() method
        const quiz_questionsData = data.map((item, index) => ({
                id: item.id || undefined,
                
                prompt: item.prompt
            ||
            null
            ,
            
                time_limit_seconds: item.time_limit_seconds
            ||
            null
            ,
            
                points: item.points
            ||
            null
            ,
            
                question_type: item.question_type
            ||
            null
            ,
            
                order_index: item.order_index
            ||
            null
            ,
            
            importHash: item.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
            createdAt: new Date(Date.now() + index * 1000),
    }));

        // Bulk create items
        const quiz_questions = await db.quiz_questions.bulkCreate(quiz_questionsData, { transaction });

        // For each item created, replace relation files
        
        for (let i = 0; i < quiz_questions.length; i++) {
            await FileDBApi.replaceRelationFiles(
                {
                    belongsTo: db.quiz_questions.getTableName(),
                    belongsToColumn: 'prompt_images',
                    belongsToId: quiz_questions[i].id,
                },
                data[i].prompt_images,
                options,
            );
        }
        

        return quiz_questions;
    }

    static async update(id, data,  options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;
        

        const quiz_questions = await db.quiz_questions.findByPk(id, {}, {transaction});


        

        const updatePayload = {};
        
        if (data.prompt !== undefined) updatePayload.prompt = data.prompt;
        
        
        if (data.time_limit_seconds !== undefined) updatePayload.time_limit_seconds = data.time_limit_seconds;
        
        
        if (data.points !== undefined) updatePayload.points = data.points;
        
        
        if (data.question_type !== undefined) updatePayload.question_type = data.question_type;
        
        
        if (data.order_index !== undefined) updatePayload.order_index = data.order_index;
        
        
        updatePayload.updatedById = currentUser.id;

        await quiz_questions.update(updatePayload, {transaction});

        
        
        if (data.quiz !== undefined) {
            await quiz_questions.setQuiz(
              
              data.quiz,
              
              { transaction }
            );
        }
        

        
        

        
        await FileDBApi.replaceRelationFiles(
            {
                belongsTo: db.quiz_questions.getTableName(),
                belongsToColumn: 'prompt_images',
                belongsToId: quiz_questions.id,
            },
            data.prompt_images,
            options,
        );
        

        return quiz_questions;
    }

    static async deleteByIds(ids, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const quiz_questions = await db.quiz_questions.findAll({
            where: {
                id: {
                    [Op.in]: ids,
                },
            },
            transaction,
        });

        await db.sequelize.transaction(async (transaction) => {
            for (const record of quiz_questions) {
                await record.update(
                    {deletedBy: currentUser.id},
                    {transaction}
                );
            }
            for (const record of quiz_questions) {
                await record.destroy({transaction});
            }
        });


        return quiz_questions;
    }

    static async remove(id, options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;

        const quiz_questions = await db.quiz_questions.findByPk(id, options);

        await quiz_questions.update({
            deletedBy: currentUser.id
        }, {
            transaction,
        });

        await quiz_questions.destroy({
            transaction
        });

        return quiz_questions;
    }

    static async findBy(where, options) {
        const transaction = (options && options.transaction) || undefined;

        const quiz_questions = await db.quiz_questions.findOne(
            { where },
            { transaction },
        );

        if (!quiz_questions) {
            return quiz_questions;
        }

        const output = quiz_questions.get({plain: true});

        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        output.question_answers_question = await quiz_questions.getQuestion_answers_question({
            transaction
        });
        
        
        
        
        
        
        
        
        output.match_questions_quiz_question = await quiz_questions.getMatch_questions_quiz_question({
            transaction
        });
        
        
        
        
        
        
        
        
        
        
        
        
        
        output.quiz = await quiz_questions.getQuiz({
            transaction
        });
        
        
        output.prompt_images = await quiz_questions.getPrompt_images({
            transaction
        });
        
        

        return output;
    }

    static async findAll(
          filter,
           options
        ) {
        const limit = filter.limit || 0;
        let offset = 0;
        let where = {};
        const currentPage = +filter.page;

        

        

        offset = currentPage * limit;

        const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [

      {
        model: db.quizzes,
        as: 'quiz',
        
        where: filter.quiz ? {
          [Op.or]: [
            { id: { [Op.in]: filter.quiz.split('|').map(term => Utils.uuid(term)) } },
            {
              title: {
                [Op.or]: filter.quiz.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },



      {
        model: db.file,
        as: 'prompt_images',
      },

    ];

        if (filter) {
            if (filter.id) {
                where = {
                    ...where,
                    ['id']: Utils.uuid(filter.id),
                };
            }

            
            if (filter.prompt) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'quiz_questions',
                        'prompt',
                        filter.prompt,
                    ),
                };
            }
            

            
            

            
            if (filter.time_limit_secondsRange) {
                const [start, end] = filter.time_limit_secondsRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    time_limit_seconds: {
                    ...where.time_limit_seconds,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    time_limit_seconds: {
                    ...where.time_limit_seconds,
                            [Op.lte]: end,
                    },
                };
                }
            }
            
            if (filter.pointsRange) {
                const [start, end] = filter.pointsRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    points: {
                    ...where.points,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    points: {
                    ...where.points,
                            [Op.lte]: end,
                    },
                };
                }
            }
            
            if (filter.order_indexRange) {
                const [start, end] = filter.order_indexRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    order_index: {
                    ...where.order_index,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    order_index: {
                    ...where.order_index,
                            [Op.lte]: end,
                    },
                };
                }
            }
            

            if (filter.active !== undefined) {
                where = {
                    ...where,
                    active: filter.active === true || filter.active === 'true'
                };
            }

            
            if (filter.question_type) {
                where = {
                    ...where,
                question_type: filter.question_type,
            };
            }
            


      



            if (filter.createdAtRange) {
                const [start, end] = filter.createdAtRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.gte]: start,
                        },
                    };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.lte]: end,
                        },
                    };
                }
            }
        }
        

        

        const queryOptions = {
            where,
            include,
            distinct: true,
            order: filter.field && filter.sort
                ? [[filter.field, filter.sort]]
                : [['createdAt', 'desc']],
            transaction: options?.transaction,
            logging: console.log
        };

        if (!options?.countOnly) {
            queryOptions.limit = limit ? Number(limit) : undefined;
            queryOptions.offset = offset ? Number(offset) : undefined;
        }

        try {
            const { rows, count } = await db.quiz_questions.findAndCountAll(queryOptions);

            return {
                rows: options?.countOnly ? [] : rows,
                count: count
            };
        } catch (error) {
            console.error('Error executing query:', error);
            throw error;
        }
    }

    static async findAllAutocomplete(query, limit, offset, ) {
        let where = {};
        
        

        if (query) {
            where = {
                [Op.or]: [
                    { ['id']: Utils.uuid(query) },
                    Utils.ilike(
                        'quiz_questions',
                        'prompt',
                        query,
                    ),
                ],
            };
        }

        const records = await db.quiz_questions.findAll({
            attributes: [ 'id', 'prompt' ],
            where,
            limit: limit ? Number(limit) : undefined,
            offset: offset ? Number(offset) : undefined,
            orderBy: [['prompt', 'ASC']],
        });

        return records.map((record) => ({
            id: record.id,
            label: record.prompt,
        }));
    }

    
};

